"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var LoggerModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoggerModule = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const nestjs_context_1 = require("./nestjs-context");
const nestjs_correlation_id_1 = require("./nestjs-correlation-id");
const nestjs_gcloud_trace_1 = require("./nestjs-gcloud-trace");
const nestjs_pino_context_1 = require("./nestjs-pino-context");
const logger_service_1 = require("./logger.service");
const tools_1 = require("./tools");
const createModuleDef = (config) => {
    const pinoContextModule = nestjs_pino_context_1.PinoContextModule.register(config);
    return {
        imports: [
            core_1.DiscoveryModule,
            nestjs_context_1.ContextModule.register(),
            nestjs_correlation_id_1.CorrelationIdModule.register(),
            nestjs_gcloud_trace_1.GcloudTraceModule,
        ],
        providers: [...pinoContextModule.providers, logger_service_1.Logger],
        exports: [...pinoContextModule.exports, logger_service_1.Logger],
    };
};
let LoggerModule = LoggerModule_1 = class LoggerModule {
    static forRoot(config = {}) {
        return LoggerModule_1.register(config);
    }
    static register(config = {}) {
        const moduleConfig = tools_1.stackdriverConfigTool(config);
        return Object.assign({ module: LoggerModule_1 }, createModuleDef(moduleConfig));
    }
};
LoggerModule = LoggerModule_1 = __decorate([
    common_1.Module(createModuleDef(tools_1.stackdriverConfigTool({})))
], LoggerModule);
exports.LoggerModule = LoggerModule;
