"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@nestjs/core");
const common_1 = require("@nestjs/common");
const example_module_1 = require("./example.module");
const src_1 = require("../../src");
const default_context_1 = require("../../src/default.context");
async function bootstrap() {
    default_context_1.defaultContext.set('example-top-level', 'default context message using the default context variable');
    const app = await core_1.NestFactory.create(example_module_1.ExampleModule);
    app.useGlobalPipes(new common_1.ValidationPipe({
        transform: true,
        validateCustomDecorators: true,
    }));
    app
        .get(src_1.Context)
        .set('example-top-level-di', 'top-level default context message using DI');
    await app.listen(9191);
}
bootstrap();
