"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createProvidersForDecorated = exports.InjectContext = void 0;
const common_1 = require("@nestjs/common");
const context_1 = require("../context");
const __nestjsPinoStackdriverContexts = new Map();
exports.InjectContext = (contextName) => {
    let symbol = __nestjsPinoStackdriverContexts.get(contextName);
    if (!symbol) {
        symbol = Symbol(contextName);
        __nestjsPinoStackdriverContexts.set(contextName, symbol);
    }
    return common_1.Inject(symbol);
};
function createProvidersForDecorated() {
    return [...__nestjsPinoStackdriverContexts].map(([contextName, symbol]) => ({
        provide: symbol,
        useValue: context_1.createContext(),
    }));
}
exports.createProvidersForDecorated = createProvidersForDecorated;
