"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExampleHandler = void 0;
const common_1 = require("@nestjs/common");
const cqrs_1 = require("@nestjs/cqrs");
const src_1 = require("../../../../../src");
const example_command_1 = require("../impl/example.command");
const example_event_1 = require("../../events/example.event");
let ExampleHandler = class ExampleHandler {
    constructor(logger) {
        this.logger = logger;
    }
    async execute(command) {
        this.logger.debug(`You can add the correlation id to a class property using the AddCorrelationId ` +
            `decorator (${this.correlationId}) or the CorrelationId decorator (${this.correlationIdAgain})`);
        const event = new example_event_1.ExampleEvent(command, { created_at: new Date() });
        this.logger.debug(`You can also add to your event::metadata property a correlation_id using ` +
            `CorrelationIdMetadata decorator (${event.metadata.correlation_id})`);
        return `Command handler printing: id: ${command.id}, correlation-id: ${command[src_1.HEADER_CORRELATION_ID]} `;
    }
};
__decorate([
    src_1.CorrelationId(),
    __metadata("design:type", String)
], ExampleHandler.prototype, "correlationIdAgain", void 0);
ExampleHandler = __decorate([
    cqrs_1.CommandHandler(example_command_1.ExampleCommand),
    src_1.AddCorrelationId('correlationId'),
    __metadata("design:paramtypes", [common_1.Logger])
], ExampleHandler);
exports.ExampleHandler = ExampleHandler;
