"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CorrelationIdConfig = void 0;
const uuid_1 = require("uuid");
const constants_1 = require("./constants");
const flickrBase58 = '123456789abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ';
const toFlickr = require('any-base')('0123456789abcdef', flickrBase58);
const shortIdGenerator = () => {
    const longId = uuid_1.v4()
        .toLowerCase()
        .replace(/-/g, '');
    return toFlickr(longId);
};
const defaultConfig = {
    headerName: constants_1.HEADER_CORRELATION_ID,
    idGenerator: shortIdGenerator,
};
class CorrelationIdConfig {
    constructor(config = {}) {
        this._config = Object.assign(Object.assign({}, defaultConfig), config);
    }
    get() {
        return this._config;
    }
}
exports.CorrelationIdConfig = CorrelationIdConfig;
