"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var CorrelationIdModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.CorrelationIdModule = void 0;
const common_1 = require("@nestjs/common");
const nestjs_context_1 = require("../../nestjs-context");
const middleware_1 = require("./middleware");
const correlation_id_config_1 = require("./correlation-id.config");
let CorrelationIdModule = CorrelationIdModule_1 = class CorrelationIdModule {
    constructor(config, context) {
        this.config = config;
        this.context = context;
    }
    static register(config = {}) {
        const correlationIdConfig = {
            provide: correlation_id_config_1.CorrelationIdConfig,
            useValue: new correlation_id_config_1.CorrelationIdConfig(config),
        };
        return {
            module: CorrelationIdModule_1,
            providers: [correlationIdConfig],
            exports: [],
        };
    }
    configure(consumer) {
        consumer
            .apply(middleware_1.correlationIdMiddleware(this.config, this.context))
            .forRoutes({ path: '*', method: common_1.RequestMethod.ALL });
    }
};
CorrelationIdModule = CorrelationIdModule_1 = __decorate([
    common_1.Module({
        imports: [nestjs_context_1.ContextModule.register()],
    }),
    __metadata("design:paramtypes", [correlation_id_config_1.CorrelationIdConfig,
        nestjs_context_1.Context])
], CorrelationIdModule);
exports.CorrelationIdModule = CorrelationIdModule;
