"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SetCorrelationIdFrom = void 0;
const lodash_1 = require("lodash");
const src_1 = require("../../../../nestjs-context/src");
const constants_1 = require("../../constants");
exports.SetCorrelationIdFrom = (path = '', index = 0) => (target, propertyKey, descriptor) => {
    const originalMethod = descriptor.value;
    descriptor.value = function (...args) {
        const argWithValue = args[index];
        const value = path !== '' ? lodash_1.get(argWithValue, path) : argWithValue;
        src_1.defaultContext.set(constants_1.CONTEXT_CORRELATION_ID, value);
        return originalMethod.apply(this, args);
    };
};
