"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.correlationIdMiddleware = void 0;
const lodash_1 = require("lodash");
const constants_1 = require("../constants");
exports.correlationIdMiddleware = (config, context) => {
    const { headerName, idGenerator } = config.get();
    return async (req, res, next) => {
        const header = lodash_1.kebabCase(headerName);
        const correlationId = (req.header(header) || idGenerator());
        req.headers[header] = correlationId;
        res.set(header, correlationId);
        if (context && context.set) {
            context.set(constants_1.CONTEXT_CORRELATION_ID, correlationId);
        }
        next();
    };
};
