"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@nestjs/core");
const common_1 = require("@nestjs/common");
const config_1 = require("@nestjs/config");
const src_1 = require("../../src");
const example_module_1 = require("./example.module");
async function bootstrap() {
    const app = await core_1.NestFactory.create(example_module_1.ExampleModule);
    const configService = app.get(config_1.ConfigService);
    if (configService.get('FORCE_REQUEST_TRACE') === 'true') {
        app.use(src_1.forceRequestToBeTracedMiddleware(app.get(src_1.GcloudTraceService), (req) => req.method === 'GET'));
    }
    app.useGlobalPipes(new common_1.ValidationPipe({
        transform: true,
        validateCustomDecorators: true,
    }));
    await app.listen(9191);
}
src_1.GcloudTraceService.start();
bootstrap();
