"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GcloudTraceModule = void 0;
const common_1 = require("@nestjs/common");
const nestjs_context_1 = require("../../nestjs-context");
const services_1 = require("./services");
const middleware_1 = require("./middleware");
let GcloudTraceModule = class GcloudTraceModule {
    constructor(gcloudTracerService, context) {
        this.gcloudTracerService = gcloudTracerService;
        this.context = context;
        this.middlewaresConfigured = false;
    }
    configure(consumer) {
        if (this.middlewaresConfigured) {
            return;
        }
        consumer
            .apply(middleware_1.gcloudTraceContextMiddleware({
            gcloudTracerService: this.gcloudTracerService,
            contextService: this.context,
        }))
            .forRoutes({ path: '*', method: common_1.RequestMethod.ALL });
        this.middlewaresConfigured = true;
    }
};
GcloudTraceModule = __decorate([
    common_1.Global(),
    common_1.Module({
        imports: [nestjs_context_1.ContextModule.register()],
        providers: [services_1.GcloudTraceService],
        exports: [services_1.GcloudTraceService],
    }),
    __metadata("design:paramtypes", [services_1.GcloudTraceService,
        nestjs_context_1.Context])
], GcloudTraceModule);
exports.GcloudTraceModule = GcloudTraceModule;
