"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.gcloudTraceContextMiddleware = void 0;
const common_1 = require("@nestjs/common");
const constants_1 = require("../constants");
exports.gcloudTraceContextMiddleware = ({ gcloudTracerService, contextService, }) => {
    return async (req, res, next) => {
        if (!gcloudTracerService.isActive()) {
            throw new common_1.InternalServerErrorException(`You must call GcloudTracerService::start from your main application`);
        }
        const contextId = gcloudTracerService.get().getCurrentContextId();
        if (contextId && contextService) {
            const traceUrl = await gcloudTracerService.getTraceUrl();
            if (traceUrl) {
                contextService.set(constants_1.CONTEXT_GCLOUD_TRACE, traceUrl);
            }
        }
        next();
    };
};
