"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@nestjs/core");
const common_1 = require("@nestjs/common");
const example_module_1 = require("./example.module");
const src_1 = require("../../../nestjs-gcloud-trace/src");
const src_2 = require("../../src");
const logger_config_1 = require("./logger.config");
async function bootstrap() {
    const app = await core_1.NestFactory.create(example_module_1.ExampleModule, {
        logger: src_2.createLoggerTool(logger_config_1.loggerConfig),
    });
    app.useGlobalPipes(new common_1.ValidationPipe({
        transform: true,
        validateCustomDecorators: true,
    }));
    await app.listen(9191);
}
src_1.GcloudTraceService.start({
    samplingRate: 1,
});
bootstrap();
