"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExampleController = void 0;
const common_1 = require("@nestjs/common");
const cqrs_1 = require("@nestjs/cqrs");
const example_command_1 = require("./command/impl/example.command");
const src_1 = require("../../src");
const decorators_1 = require("../../../nestjs-ps-tools/src/decorators");
let ExampleController = class ExampleController {
    constructor(commandBus, logger) {
        this.commandBus = commandBus;
        this.logger = logger;
    }
    async example(command) {
        this.logger.verbose(`Simple verbose message from the controller - id: ${command.id}`);
        this.logger.debug({
            msg: 'Object-like debug message',
            sample: 'another field',
        });
        this.logger.warn('Warning passing custom context', 'custom-context');
        return this.commandBus.execute(command);
    }
};
__decorate([
    common_1.Post('/example/:id'),
    __param(0, decorators_1.BuildDto([{ body: ['id'], params: ['id'] }, { body: ['override-id'] }])),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [example_command_1.ExampleCommand]),
    __metadata("design:returntype", Promise)
], ExampleController.prototype, "example", null);
ExampleController = __decorate([
    common_1.Controller(),
    __metadata("design:paramtypes", [cqrs_1.CommandBus,
        src_1.PinoContextLogger])
], ExampleController);
exports.ExampleController = ExampleController;
