"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.loggerConfig = void 0;
const enums_1 = require("../../src/enums");
exports.loggerConfig = process.env.NODE_ENV !== 'production'
    ? {
        base: enums_1.PredefinedConfig.STACKDRIVER,
        logFieldNames: {
            trace: 'error',
        },
        labels: {
            env: [
                {
                    label: 'project',
                    value: 'example',
                },
                { label: 'node-env', path: 'NODE_ENV' },
            ],
            request: [
                {
                    label: 'content-type',
                    pick: { headers: ['content-type'] },
                },
                {
                    label: 'visible-if-fallback-id',
                    pick: { query: ['fallback-id'], body: ['not-shown'] },
                },
                {
                    label: 'entity-id',
                    pick: [
                        { body: ['id'], params: ['id'] },
                        {
                            body: ['override-id'],
                            filter: (req) => !req.body['block-override'],
                        },
                    ],
                },
                {
                    label: 'deep-in-body',
                    pick: [{ body: ['deep.id'] }],
                    path: 'deep-in-body.id',
                },
            ],
        },
    }
    : enums_1.PredefinedConfig.STACKDRIVER;
