import { LoggerService } from '@nestjs/common';
import * as createPinoLogger from 'pino';
import { Context } from '../../nestjs-context';
import { PinoContextConfig } from './pino-context.config';
export declare class PinoContextLogger implements LoggerService {
    readonly config: PinoContextConfig;
    private readonly contextStorage;
    private logger;
    private context;
    constructor(config?: PinoContextConfig, contextStorage?: Context, logger?: createPinoLogger.Logger);
    setContext(context: string): void;
    hasContext(): boolean;
    private buildFieldsForConfigHelper;
    private buildFieldsForContextConfig;
    private buildFieldsForRequestConfig;
    private buildFieldsForEnvConfig;
    private buildFields;
    setLabel(label: string, value: any): this;
    private getMergingObject;
    verbose(message: any, context?: string, ...args: any[]): void;
    debug(message: any, context?: string, ...args: any[]): void;
    log(message: any, context?: string, ...args: any[]): void;
    warn(message: any, context?: string, ...args: any[]): void;
    error(message: any, trace?: string, context?: string, ...args: any[]): void;
}
