"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var PinoContextModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.PinoContextModule = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const nestjs_context_1 = require("../../nestjs-context");
const pino_context_logger_service_1 = require("./pino-context-logger.service");
const pino_context_request_interceptor_1 = require("./pino-context-request.interceptor");
const pino_context_config_1 = require("./pino-context.config");
const set_context_for_logger_instances_explorer_1 = require("./set-context-for-logger-instances.explorer");
const moduleDef = {
    imports: [core_1.DiscoveryModule, nestjs_context_1.ContextModule.register()],
    providers: [
        set_context_for_logger_instances_explorer_1.SetContextForLoggerInstancesExplorer,
        {
            provide: pino_context_config_1.PinoContextConfig,
            useValue: new pino_context_config_1.PinoContextConfig({}),
        },
        pino_context_logger_service_1.PinoContextLogger,
        {
            provide: core_1.APP_INTERCEPTOR,
            useClass: pino_context_request_interceptor_1.PinoContextRequestInterceptor,
        },
    ],
    exports: [pino_context_logger_service_1.PinoContextLogger, pino_context_config_1.PinoContextConfig],
};
let PinoContextModule = PinoContextModule_1 = class PinoContextModule {
    static register(configModule = {}) {
        const config = new pino_context_config_1.PinoContextConfig(configModule);
        const ConfigProvider = {
            provide: pino_context_config_1.PinoContextConfig,
            useValue: config,
        };
        return Object.assign(Object.assign({ module: PinoContextModule_1 }, moduleDef), { providers: [...moduleDef.providers, ConfigProvider] });
    }
};
PinoContextModule = PinoContextModule_1 = __decorate([
    common_1.Module(moduleDef)
], PinoContextModule);
exports.PinoContextModule = PinoContextModule;
