"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SetContextForLoggerInstancesExplorer = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const pino_context_logger_service_1 = require("./pino-context-logger.service");
let SetContextForLoggerInstancesExplorer = class SetContextForLoggerInstancesExplorer {
    constructor(discoveryService) {
        this.discoveryService = discoveryService;
    }
    onModuleInit() {
        this.explore();
    }
    explore() {
        const setContext = (wrapper) => {
            if (!wrapper.instance) {
                return;
            }
            Object.values(wrapper.instance).forEach(service => {
                if (service &&
                    service instanceof pino_context_logger_service_1.PinoContextLogger &&
                    !service.hasContext()) {
                    service.setContext(wrapper.name);
                }
            });
        };
        this.discoveryService
            .getProviders()
            .forEach((wrapper) => setContext(wrapper));
        this.discoveryService
            .getControllers()
            .forEach((wrapper) => setContext(wrapper));
    }
};
SetContextForLoggerInstancesExplorer = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [core_1.DiscoveryService])
], SetContextForLoggerInstancesExplorer);
exports.SetContextForLoggerInstancesExplorer = SetContextForLoggerInstancesExplorer;
